#include <bits/stdc++.h>
using namespace std;

#define MAX 200010
#define LOGMAX 20

// Sparse table for lca
int parent[MAX][LOGMAX];

int level[MAX];

int nodeCount[MAX];

int leaves = 0;

int N;
vector<int> graph[MAX];

void dfs(int node, int par)
{
    if (graph[node].size() == 1)
        leaves++;

    if (par != -1)
        level[node] = level[par] + 1;

    // Fill sparse table for current node.
    parent[node][0] = par;

    for (int k = 1; k < LOGMAX; k++)
    {
        if (parent[node][k-1] != -1)
        {
            parent[node][k] = parent[parent[node][k-1]][k-1];
        }
    }

    for (int i = 0; i < graph[node].size(); i++)
    {
        int target = graph[node][i];

        if (target != par)
        {
            dfs(target, node);
        }
    }
}

int getLca(int u, int v)
{
    if (level[v] < level[u])
        swap(v, u);


    for (int k = LOGMAX - 1; k >= 0; k--)
    {
        if (parent[v][k] != -1 && level[parent[v][k]] >= level[u])
        {
            v = parent[v][k];
        }
    }

    if (v == u)
        return v;

    for (int k = LOGMAX - 1; k >= 0; k--)
    {
        if (parent[v][k] != parent[u][k])
        {
            v = parent[v][k];
            u = parent[u][k];
        }
    }

    return parent[v][0];
}


void getCount(int node, int par)
{
    for (int i = 0; i < graph[node].size(); i++)
    {
        int target = graph[node][i];

        if (target == par) continue;

        getCount(target, node);

        nodeCount[node] += nodeCount[target];
    }
}

int checkAnswer()
{
    for (int i = 1; i <= N; i++)
    {
        if (nodeCount[i] < 1)
            return -1;
    }
    return 0;
}



int ActualSolution;
int UserSolution;

int userEdgeA[MAX], userEdgeB[MAX];


vector<pair<int,int> > outputEdges;

int main(int argc, char *argv[])
{
    ifstream outFile(argv[1]);
    ifstream solFile(argv[2]);
    ifstream inFile(argv[3]);

    memset(parent, -1, sizeof(parent));

    inFile >> N;

    int a, b;
    for (int i = 0; i < N - 1; i++)
    {
        inFile >> a >> b;
        graph[a].push_back(b);
        graph[b].push_back(a);
    }

    dfs(1, -1);

    ActualSolution = (leaves + 1) / 2;

    if (N == 1)
        ActualSolution = 1;

    if (!outFile.eof())
    {
        outFile >> UserSolution;

        if (UserSolution != ActualSolution)
            return -1;
    }
    else
    {
        return -1; // User didnt print out anything
    }


    for (int i = 0; i < ActualSolution; i++)
    {
        if (!outFile.eof())
        {
            outFile >> userEdgeA[i];

            if (!outFile.eof())
            {
                outFile >> userEdgeB[i];
            }
            else
            {
                return -1;
            }
        }
        else
        {
            return -1;
        }
    }

    // User has right solution and number of edges
    // Now check if they cover all nodes


    for (int i = 0; i < ActualSolution; i++)
    {
        int a = userEdgeA[i];
        int b = userEdgeB[i];

        int LCA = getLca(a, b);

        nodeCount[a] += 1;
        nodeCount[b] += 1;

        nodeCount[LCA] -= 1;

        if (parent[LCA][0] != -1)
            nodeCount[parent[LCA][0]] -= 1;
    }

    getCount(1, -1);

    //cout << checkAnswer() << endl;

    /*
    for (int i = 1; i <= N; i++)
    {
        cout << nodeCount[i] << endl;
    }
    */
    return checkAnswer();

}
